<template>
  <!-- Input container -->
  <div :class="`_input-container ${fluid ? 'w-full' : ''}`">
    <!-- Slot: label -->
    <slot name="label">
      <div
        v-if="label.length > 0"
        :class="`_input-label ${labelClass}`"
      >
        <label :for="name">{{ label }}</label>
        <span v-if="required"> *</span>
      </div>
    </slot>

    <!-- Slot: input -->
    <slot name="input">
      <div :class="`_input mb-2 ${inputClass} ${fluid ? 'w-full' : ''}`">
        <!-- Button -->
        <Button
          :variant="variant"
          inline
          @click.native="handleButtonClick"
        >
          <v-icon
            name="upload"
            class="mr-1"
          /> {{ buttonLabel }}
        </Button>

        <!-- Uploaded file name -->
        <div
          v-if="vModel"
          class="inline-block ml-4"
        >
          {{ $t('global.file') | capitalize }}: {{ vModel.name }}
        </div>

        <!-- Hidden input -->
        <input
          :ref="inputRef"
          class="hidden"
          type="file"
          :name="name"
          :capture="capture"
          :accept="accept"
          placeholder="Choose a file or drop it here..."
          drop-placeholder="Drop file here..."
          @change="updateFile"
        >
      </div>
    </slot>

    <!-- Slot: description -->
    <slot name="description">
      <!-- Description -->
      <div
        v-if="description.length > 0"
        :class="`_input-description ${descriptionClass} ${fluid ? 'w-full' : ''}`"
      >
        <p>{{ description }}</p>
      </div>
    </slot>

    <!-- Slot: error -->
    <slot name="error">
      <!-- Error message -->
      <div
        v-if="error.length > 0"
        :class="`_input-error ${errorClass} ${fluid ? 'w-full' : ''}`"
      >
        <p>{{ error }}</p>
      </div>
    </slot>
  </div>
</template>

<script>
import BaseInput from './BaseInput'
/**
 * InputFile component
 */
export default {
  name: 'InputFile',
  extends: BaseInput,
  props: {
    /**
     * Override 'value' prop
     * See -> ./BaseInput.vue
     */
    value: {
      type: File, // Because input value is null or File
      default: null
    },
    /**
     * Called before click event
     * ⚠ Must return true to continue in callback queue
     */
    beforeClick: {
      type: Function,
      default () {
        return (event) => true
      }
    },
    /**
     * Called on click event
     * ⚠ Must return true to continue in callback queue
     */
    onClick: {
      type: Function,
      default () {
        return (event) => true
      }
    },
    /**
     * Called after click event
     * ⚠ Must return true to continue in callback queue
     */
    afterClick: {
      type: Function,
      default () {
        return (event) => true
      }
    },
    /**
     * The button label. Useless if "input" slot is overridden
     */
    buttonLabel: {
      type: String,
      default () {
        return this.$filters.capitalize(this.$t('global.upload'))
      }
    }
  },
  methods: {
    /**
     * Update input value with first file
     * @return {void}
     */
    updateFile: function () {
      const file = this.$refs[this.inputRef].files[0]
      this.vModel = file
    },
    /**
     * Handle click on input button.
     * @async
     * @param {object} event - The event payload
     * @returns {void}
     */
    async handleButtonClick (event) {
      event.preventDefault()
      // Before click
      let next = await this.beforeClick(event)
      if (next) {
        // On click
        next = await this.onClick(event)
        if (next) {
          // Simulate click on hidden input
          this.$refs[this.inputRef].click()
          // After click
          next = await this.afterClick(event)
        }
      }
      return next
    }
  }
}
</script>
